Bug 243311 - printk in atomic can schedule
printk in atomic can schedule
Status: CLOSED CURRENTRELEASE
Product: Red Hat Enterprise MRG
Classification: Red Hat
Component: realtime-kernel (Show other bugs)
1.0
All Linux
high Severity high
: ---
: ---
Assigned To: Steven Rostedt
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-06-08 10:59 EDT by Steven Rostedt
Modified: 2008-02-27 14:56 EST (History)
1 user (show)

See Also:
Fixed In Version: 2.6.21-35.el5rt
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-07-26 10:36:10 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Steven Rostedt 2007-06-08 10:59:32 EDT
Description of problem:
printk calls consol functions that write to the appropriate devices.
But in the PREEMPT_RT kernel, some of these console functions grab
spin locks that are converted to mutexes.  This means that calling
printk in an atomic operation or from interrupt contex can schedule
and cause undefined results.

Version-Release number of selected component (if applicable):


How reproducible:


Steps to Reproduce:
1.
2.
3.
  
Actual results:


Expected results:


Additional info:
I need to write a patch that will add an ATOMIC_SAFE flag to the console
drivers. This will be checked if printk is called from an atomic
operation. If the console is not safe, then printk will skip that
console.  Current consoles that should be atomic safe, is the VGA
console as well as early_printk console.
Comment 1 Clark Williams 2007-07-26 10:36:10 EDT
Patch applied 

Note You need to log in before you can comment on or make changes to this bug.